%global momorel 1

%define desktop_file_utils_version 0.9
%define nspr_version 4.6
%define nss_version 3.11.1
%define cairo_version 0.5
%global langpacks_date 20080208

#%%define indexhtml file:///usr/share/doc/HTML/index.html
%define builddir %{_builddir}/mozilla
%define build_devel_package 1

%define official_branding 0

%ifarch ppc64
%global optflags %(echo %{optflags} -mminimal-toc)
%endif

Summary:        Mozilla Firefox Web browser.
Name:           firefox
Version:        2.0.0.12
Release: %{momorel}m%{?dist}
URL:            http://www.mozilla.org/projects/firefox/
License:        MPL and GPL and LGPL
Group:          Applications/Internet
Source0: http://ftp.iij.ad.jp/pub/mozilla/mozilla.org/firefox/releases/%{version}/source/firefox-%{version}-source.tar.bz2
NoSource: 0
Source2:        firefox-langpacks-%{version}-%{langpacks_date}.tar.bz2
Source10:       firefox-mozconfig
Source11:       firefox-mozconfig-branded
Source12:       firefox-momonga-default-bookmarks.html
Source13:       firefox-momonga-default-prefs.js
# http://ftp.iij.ad.jp/pub/mozilla/mozilla-japan/firefox/development/2.0/
Source15:       firefox-2.0.ja.searchplugins-1.5.16.tar.bz2
Source20:       firefox.desktop
Source21:       firefox.sh.in
Source22:       firefox.png
Source23:       firefox.1
Source50:       firefox-xremote-client.sh.in
Source100:      find-external-requires
Source101:      add-gecko-provides.in

# build patches
Patch1:         firefox-2.0-link-layout.patch
Patch3:         firefox-1.1-nss-system-nspr.patch
Patch4:         firefox-1.5-with-system-nss.patch

# customization patches
Patch20:        firefox-redhat-homepage.patch
Patch21:        firefox-0.7.3-psfonts.patch
Patch22:        firefox-1.1-default-applications.patch
Patch23:        firefox-1.1-software-update.patch
Patch24:        firefox-RC1-stock-icons-be.patch
Patch25:        firefox-RC1-stock-icons-fe.patch
Patch26:        firefox-RC1-stock-icons-gnomestripe.patch
Patch27:        firefox-gnomestripe-0.1-livemarks.patch

# local bugfixes
Patch40:        firefox-1.5-bullet-bill.patch
Patch41:        firefox-2.0.0.4-undo-uriloader.patch
Patch42:        firefox-1.1-uriloader.patch
Patch43:        thunderbird-1.5.0.9-bug367203.patch

# font system fixes
Patch82:        firefox-1.5-pango-mathml.patch
Patch83:        firefox-1.5-pango-cursor-position.patch
Patch84:        firefox-2.0-pango-printing.patch
Patch85:        firefox-2.0-pango-ligatures.patch
Patch86:        firefox-1.5-pango-cursor-position-more.patch
Patch87:        firefox-1.5-pango-justified-range.patch
Patch88:        firefox-1.5-pango-underline.patch
Patch89:        firefox-1.5-xft-rangewidth.patch

# Other
Patch102:       firefox-1.5-theme-change.patch
Patch104:       firefox-1.5-ppc64.patch

# Momonga's patch
Patch1000:	firefox-2.0.0.2-fix-include-path.patch

%if %{official_branding}
# Required by Mozilla Corporation


%else
# Not yet approved by Mozillla Corporation


%endif

# ---------------------------------------------------

BuildRoot:  %{_tmppath}/%{name}-%{version}-root
BuildRequires:  nspr-devel >= %{nspr_version}
BuildRequires:  nss-devel >= %{nss_version}
BuildRequires:  cairo-devel >= %{cairo_version}
BuildRequires:  libpng-devel, libjpeg-devel
BuildRequires:  zlib-devel, zip
BuildRequires:  libIDL-devel
BuildRequires:  desktop-file-utils
BuildRequires:  gtk+-devel >= 2.8.3-2m
BuildRequires:  gnome-vfs-devel
BuildRequires:  libgnome-devel
BuildRequires:  libgnomeui-devel
BuildRequires:  krb5-devel
BuildRequires:  pango-devel
BuildRequires:  freetype-devel >= 2.1.9
BuildRequires:  libXt-devel
BuildRequires:  libXrender-devel

PreReq:        desktop-file-utils
Requires:       nspr >= %{nspr_version}
Requires:       nss >= %{nss_version}
Requires:       desktop-file-utils >= %{desktop_file_utils_version}
Obsoletes:      phoenix, mozilla-firebird, MozillaFirebird
Provides:       webclient
%define mozappdir %{_libdir}/firefox-%{version}

%define _use_internal_dependency_generator 0

%if %{build_devel_package}
%define __find_provides %{_builddir}/add-gecko-provides
%else
%define __find_requires %{SOURCE100}
%endif

%description
Mozilla Firefox is an open-source web browser, designed for standards
compliance, performance and portability.

%if %{build_devel_package}
%package devel
Summary: Development files for Firefox
Group: Development/Libraries
Requires: firefox = %{version}-%{release}
Requires: nspr-devel >= %{nspr_version}
Requires: nss-devel >= %{nss_version}

%description devel
Development files for Firefox.  This package exists temporarily.
When xulrunner has reached version 1.0, firefox-devel will be
removed in favor of xulrunner-devel.
%endif

#---------------------------------------------------------------------

%prep
%setup -q -n mozilla
%patch1   -p1 -b .link-layout
#%patch3  -p1
#%patch4  -p1

#%patch20 -p0
%patch21 -p1 -b .psfonts
%patch22 -p0 -b .default-applications
#%patch23 -p0
#%patch24 -p0
#%patch25 -p0
#%patch26 -p0
#%patch27 -p1
%patch40 -p1 -b .bullet-bill
%patch41 -p1 -b .undo-uriloader
%patch42 -p0 -b .uriloader
#%patch82 -p1 -b .pango-mathml
%patch83 -p1 -b .pango-cursor-position
%patch84 -p0 -b .pango-printing
%patch85 -p1 -b .pango-ligatures
%patch86 -p1 -b .pango-cursor-position-more
%patch87 -p1 -b .pango-justified-range
%patch88 -p1 -b .pango-underline
%patch89 -p1 -b .nopangoxft2

%patch102 -p0 -b .theme-change
%patch104 -p1 -b .ppc64

# For branding specific patches.

%if %{official_branding}
# Required by Mozilla Corporation


%else
# Not yet approved by Mozilla Corporation


%endif

# momonga's patch
%patch1000 -p1 -b .fix-include-path~


%{__rm} -f .mozconfig
%{__cp} %{SOURCE10} .mozconfig
%if %{official_branding}
%{__cat} %{SOURCE11} >> .mozconfig
%endif

# set up our default bookmarks
%{__cp} %{SOURCE12} profile/defaults/bookmarks.html

# replace searchplugins at en-US
%{__rm} -rf browser/locales/en-US/searchplugins/
%{__tar} -C browser/locales/en-US -xzf %{SOURCE15}


#---------------------------------------------------------------------

%build

# Build with -Os as it helps the browser; also, don't override mozilla's warning
# level; they use -Wall but disable a few warnings that show up _everywhere_
MOZ_OPT_FLAGS=$(echo $RPM_OPT_FLAGS | %{__sed} -e 's/-O2/-Os/' -e 's/-Wall//')

export RPM_OPT_FLAGS=$MOZ_OPT_FLAGS

export PREFIX='%{_prefix}'
export LIBDIR='%{_libdir}'

%ifarch ppc ppc64 s390 s390x
%define moz_make_flags -j1
%else
%define moz_make_flags %{?_smp_mflags}
%endif

export LDFLAGS="-Wl,-rpath,%{mozappdir}"
export MAKE="gmake %{moz_make_flags}"
%{__make} -f client.mk build

#---------------------------------------------------------------------

%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot} %{__make} install

%{__mkdir_p} %{buildroot}{%{_libdir},%{_bindir},%{_datadir}/applications}

%{__install} -p -D %{SOURCE22} %{buildroot}%{_datadir}/pixmaps/%{name}.png

desktop-file-install --vendor mozilla \
  --dir %{buildroot}%{_datadir}/applications \
  --add-category WebBrowser \
  --add-category Network \
  %{SOURCE20} 

# set up the firefox start script
%{__cat} %{SOURCE21} | %{__sed} -e 's,FIREFOX_VERSION,%{version},g' > \
  %{buildroot}%{_bindir}/firefox
%{__chmod} 755 %{buildroot}%{_bindir}/firefox

# set up our default preferences
%{__cat} %{SOURCE13} | %{__sed} -e 's,FIREFOX_RPM_VR,%{version}-%{release},g' > mo-default-prefs
%{__cp} mo-default-prefs %{buildroot}/%{mozappdir}/greprefs/all-momonga.js
%{__cp} mo-default-prefs %{buildroot}/%{mozappdir}/defaults/pref/all-momonga.js
%{__rm} mo-default-prefs

# set up our default bookmarks
%{__install} -p -D %{SOURCE12} %{buildroot}%{mozappdir}/defaults/profile/bookmarks.html

%{__cat} %{SOURCE50} | %{__sed} -e 's,FFDIR,%{mozappdir},g' -e 's,LIBDIR,%{_libdir},g' > \
  %{buildroot}%{mozappdir}/firefox-xremote-client

%{__chmod} 755 %{buildroot}%{mozappdir}/firefox-xremote-client
%{__install} -p -D -m 644 %{SOURCE23} %{buildroot}%{_mandir}/man1/firefox.1

%{__rm} -f %{buildroot}%{mozappdir}/firefox-config

cd %{buildroot}%{mozappdir}/chrome
find . -name "*" -type d -maxdepth 1 -exec %{__rm} -rf {} \;
cd -

%{__cat} > %{buildroot}%{mozappdir}/defaults/pref/firefox-l10n.js << EOF
pref("general.useragent.locale", "chrome://global/locale/intl.properties");
EOF
%{__chmod} 644 %{buildroot}%{mozappdir}/defaults/pref/firefox-l10n.js

%{__mkdir_p} %{buildroot}%{mozappdir}/chrome/icons/default/
%{__cp} other-licenses/branding/%{name}/default.xpm \
        %{buildroot}%{mozappdir}/chrome/icons/default/ 
%{__cp} other-licenses/branding/%{name}/default.xpm \
        %{buildroot}%{mozappdir}/icons/

# own mozilla plugin dir (#135050)
%{__mkdir_p} %{buildroot}%{_libdir}/mozilla/{components,plugins}

# make aliases for %%{mozappdir}
# ln -s %{mozappdir} %{buildroot}%{_libdir}/firefox-2.0.0.1
# ln -s %{mozappdir} %{buildroot}%{_libdir}/firefox-2.0.0.2

# Install langpacks
%{__mkdir_p} %{buildroot}%{mozappdir}/extensions
%{__tar} xjf %{SOURCE2}
for langpack in `ls firefox-langpacks/*.xpi`; do
  language=`basename $langpack .xpi`
  extensiondir=%{buildroot}%{mozappdir}/extensions/langpack-$language@firefox.mozilla.org
  %{__mkdir_p} $extensiondir
  unzip $langpack -d $extensiondir
  find $extensiondir -type f | xargs chmod 644

  tmpdir=`mktemp -d %{name}.XXXXXXXX`
  langtmp=$tmpdir/%{name}/langpack-$language
  %{__mkdir_p} $langtmp
  jarfile=$extensiondir/chrome/$language.jar
  unzip $jarfile -d $langtmp
##  sed -i -e "s|browser.startup.homepage.*$|browser.startup.homepage=%{indexhtml}|g;" $langtmp/locale/browser-region/region.properties
  find $langtmp -type f | xargs chmod 644
  %{__rm} -rf $jarfile
  cd $langtmp
  zip -r -D $jarfile locale
  cd -
  %{__rm} -rf $tmpdir
done
%{__rm} -rf firefox-langpacks

# Prepare our devel package
%if %{build_devel_package}
%{__mkdir_p} %{buildroot}/%{_includedir}/firefox-%{version}
%{__mkdir_p} %{buildroot}/%{_datadir}/idl/firefox-%{version}
%{__mkdir_p} %{buildroot}/%{_libdir}/pkgconfig
%{__cp} -rL dist/include/* \
  %{buildroot}/%{_includedir}/firefox-%{version}
%{__cp} -rL dist/idl/* \
  %{buildroot}/%{_datadir}/idl/firefox-%{version}
install -c -m 755 dist/bin/xpcshell \
  dist/bin/xpidl \
  dist/bin/xpt_dump \
  dist/bin/xpt_link \
  %{buildroot}/%{mozappdir}
install -c -m 644 build/unix/*.pc \
  %{buildroot}/%{_libdir}/pkgconfig
# fix permisson (from 2.0.0.8)
find %{buildroot}/%{_includedir}/firefox-%{version} -type f | xargs chmod 644
%endif

# GRE stuff
%ifarch x86_64 ia64 ppc64 s390x
%define gre_conf_file gre64.conf
%else
%define gre_conf_file gre.conf
%endif

%{__mkdir_p} %{buildroot}/etc/gre.d/
%{__cat} > %{buildroot}/etc/gre.d/%{gre_conf_file} << EOF
[%{version}]
GRE_PATH=%{mozappdir}
EOF

GECKO_VERSION=$(./config/milestone.pl --topsrcdir='.')
%{__cat} %{SOURCE101} | %{__sed} -e "s/@GECKO_VERSION@/$GECKO_VERSION/g" > \
                        %{_builddir}/add-gecko-provides
chmod 700 %{_builddir}/add-gecko-provides

# Copy over the LICENSE
install -c -m 644 LICENSE %{buildroot}%{mozappdir}

# ghost files
touch %{buildroot}%{mozappdir}/components/compreg.dat
touch %{buildroot}%{mozappdir}/components/xpti.dat


#---------------------------------------------------------------------

%clean
%{__rm} -rf %{buildroot}

#---------------------------------------------------------------------

%post
update-desktop-database %{_datadir}/applications

%postun
update-desktop-database %{_datadir}/applications

%preun
# is it a final removal?
if [ $1 -eq 0 ]; then
  %{__rm} -rf %{mozappdir}/components
  %{__rm} -rf %{mozappdir}/extensions
fi

%files
%defattr(-,root,root,-)
%{_bindir}/firefox
%exclude %{_bindir}/firefox-config
%{_mandir}/man1/*
%{_datadir}/applications/mozilla-%{name}.desktop
%{_datadir}/pixmaps/firefox.png
%{_libdir}/mozilla
%dir /etc/gre.d
/etc/gre.d/%{gre_conf_file}

%dir %{mozappdir}
#%%{_libdir}/firefox-2.0.0.1
#%%{_libdir}/firefox-2.0.0.2
%{mozappdir}/LICENSE
%{mozappdir}/*.properties
%{mozappdir}/chrome
%{mozappdir}/chrome.manifest
%{mozappdir}/dictionaries
%dir %{mozappdir}/components
%ghost %{mozappdir}/components/compreg.dat
%ghost %{mozappdir}/components/xpti.dat
%{mozappdir}/components/*.so
%{mozappdir}/components/*.xpt
%{mozappdir}/components/*.js
%{mozappdir}/defaults
%{mozappdir}/extensions
%{mozappdir}/greprefs
%{mozappdir}/icons
%{mozappdir}/init.d
%{mozappdir}/plugins
%{mozappdir}/res
%{mozappdir}/searchplugins
%{mozappdir}/*.so
%{mozappdir}/firefox-bin
%{mozappdir}/firefox-xremote-client
%{mozappdir}/mozilla-xremote-client
%{mozappdir}/run-mozilla.sh
%{mozappdir}/regxpcom
# XXX See if these are needed still
%{mozappdir}/updater*

%if %{build_devel_package}
%files devel
%defattr(-,root,root)
%{_datadir}/idl/firefox-%{version}
%{_includedir}/firefox-%{version}
%{mozappdir}/TestGtkEmbed
%{mozappdir}/xpcshell
%{mozappdir}/xpicleanup
%{mozappdir}/xpidl
%{mozappdir}/xpt_dump
%{mozappdir}/xpt_link
%{_libdir}/pkgconfig/firefox-xpcom.pc
%{_libdir}/pkgconfig/firefox-plugin.pc
%{_libdir}/pkgconfig/firefox-js.pc
%{_libdir}/pkgconfig/firefox-gtkmozembed.pc
%exclude %{_libdir}/pkgconfig/firefox-nspr.pc
%exclude %{_libdir}/pkgconfig/firefox-nss.pc
%endif

#---------------------------------------------------------------------

%changelog
* Sun Feb 10 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (2.0.0.12-1m)
- update to 2.0.0.12

* Sat Dec  1 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.0.0.11-1m)
- update to 2.0.0.11
- bugfix release

* Wed Nov 28 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.0.0.10-1m)
- update to 2.0.0.10
- [SECURITY] MFSA 2007-39 MFSA 2007-38 MFSA 2007-37

* Fri Nov  2 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.0.0.9-1m)
- update to 2.0.0.9
- bugfix release

* Fri Oct 19 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.0.0.8-1m)
- update to 2.0.0.8
- [SECURITY] MFSA 2007-36 MFSA 2007-35 MFSA 2007-34 MFSA 2007-33
-            MFSA 2007-32 MFSA 2007-31 MFSA 2007-30 MFSA 2007-29 
- remove Patch81 firefox-1.5-nopangoxft.patch, now in upstream tarball

* Wed Sep 19 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.0.0.7-1m)
- update to 2.0.0.7
- [SECURITY] MFSA 2007-28

* Tue Aug  7 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.0.0.6-2m)
- remove pt-PT.xpi(broken) in firefox-langpacks-2.0.0.6-20070726.tar.bz2
- appear popup messsage "...install.rdf..." at initial start.

* Mon Aug  6 2007 Masanobu Sato <satoshiga@momonga-linux.org>
- (2.0.0.6-1m)
- update to 2.0.0.6
- [SECURITY] MFSA 2007-26 MFSA 2007-27

* Thu Jul 19 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (2.0.0.5-1m)
- sync with fc-devel
--* Wed Jul 18 2007 Kai Engert <kengert@redhat.com> - 2.0.0.5-2
--- Update to 2.0.0.5
--* Fri Jun 29 2007 Martin Stransky <stransky@redhat.com> 2.0.0.4-3
--- backported pango patches from FC6 (1.5.0.12)

* Sun Jun 24 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.0.0.4-4m)
- add %%{_libdir}/mozilla/components for plugins

* Thu Jun 21 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (2.0.0.4-3m)
- add make option : --enable-ldap
-- Need OpenOffice.org-2.2.1
- PreReqs desktop-file-utils

* Tue Jun  5 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (2.0.0.4-2m)
- sync with fc-devel (firefox-2_0_0_4-2_fc)
-* Sun Jun  3 2007 Christopher Aillon <caillon@redhat.com> 2.0.0.4-2
-- Properly clean up threads with newer NSPR

* Sat Jun  2 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (2.0.0.4-1m)
- update to 2.0.0.4
-- sync with fc-devel (firefox-2_0_0_4-1_fc8)
--- Use mktemp for temp dirs
--- Fix permissions of the man page

* Sat Mar 31 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.0.0.3-3m)
- BuildRequires: freetype2-devel -> freetype-devel

* Sun Mar 25 2007 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.0.0.3-2m)
- delete symlink to 2.0.0.1, 2.0.0.2

* Thu Mar 22 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (2.0.0.3-1m)
- [SECURITY] MFSA 2007-11
- update to 2.0.0.3

* Mon Feb 26 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (2.0.0.2-4m)
- add firefox-2.0.0.2-fix-include-path.patch

* Sun Feb 25 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.0.0.2-3m)
- revise %%files to avoid conflicting

* Sun Feb 25 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (2.0.0.2-2m)
- set MOZ_DISABLE_PANGO=1 again
- make aliases for %%{mozappdir}

* Sun Feb 25 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (2.0.0.2-1m)
- [SECURITY] MFSA 2007-09 MFSA 2007-08 MFSA 2007-07 MFSA 2007-06 MFSA 2007-05
             MFSA 2007-04 MFSA 2007-03 MFSA 2007-02 MFSA 2007-01
- sync with fc-devel (firefox-2_0_0_2-1_fc7)
--* Fri Feb 23 2007 Martin Stransky <stransky@redhat.com> 2.0.0.2-1
--- Update to 2002
--* Wed Feb 21 2007 David Woodhouse <dwmw2@redhat.com> 2.0.0.1-6
--- Fix PPC64 runtime
--- Fix firefox script to use 32-bit browser by default on PPC64 hardware
--* Fri Feb  9 2007 Christopher Aillon <caillon@redhat.com> 2.0.0.1-5
--- Start using the specified locale
--* Tue Jan 30 2007 Christopher Aillon <caillon@redhat.com> 2.0.0.1-4
--- Fix the DND implementation to not grab, so it works with new GTK+.
--* Thu Jan 18 2007 Christopher Aillon <caillon@redhat.com> 2.0.0.1-3
--- Remove the XLIB_SKIP_ARGB_VISUALS=1 workaround; the plugin got fixed.
--* Fri Dec 22 2006 Christopher Aillon <caillon@redhat.com> 2.0.0.1-2
--- Strip out some frequent warnings; they muddy up the build output

* Sat Jan 27 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.0.0.1-8m)
- add ja.searchplugins
- revised default-prefs.js(useragent, homepage)
- revised default-bookmarks.html

* Mon Jan 22 2007 Masanobu Sato <satoshiga@momonga-linux.org>
- (2.0.0.1-7m)
- add thunderbird-1.5.0.9-bug367203.patch for drag and drop broken at gtk+-2.10.8
- see https://bugzilla.mozilla.org/show_bug.cgi?id=367203

* Sun Jan  7 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.0.0.1-6m)
- set official_branding 1
- set MOZILLA_OFFICIAL=0, BUILD_OFFICIAL=0 at firefox-mozconfig
- see http://www.mozilla.org/foundation/trademarks/

* Sun Jan  7 2007 Dai OKUYAMA <dai@ouchi.nahi.to>
- (2.0.0.1-5m)
- enable ppc64

* Thu Dec 28 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.0.0.1-4m)
- update firefox.sh.in

* Thu Dec 28 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.0.0.1-3m)
- revise firefox.sh.in

* Thu Dec 28 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.0.0.1-2m)
- modify MOZ_OPT_FLAGS
- update pango-printing.patch (build fix)
- remove Obsoletes: mozilla, seamonkey Provides: and Obsoletes: mozilla

* Fri Dec 22 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (2.0.0.1-1m)
- Update to 2.0.0.1
-- Removed firefox-2.0-visibility.patch
-- Modified firefox-2.0-pango-printing.patch
- Added Obsoletes: mozilla

* Sat Nov 11 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (2.0-1m)
- Imported from fc-devel (firefox-2_0-2_fc7)

